from __future__ import division
import paper
import cairo
from util import mm
from math import pi

def subactivity_init(api):
    api.declare_subactivity('checker', ScreenOfCircles())

class ScreenOfCircles(paper.Drawing):
    def draw(self,c):
        self.set_background_color('white')
        c.set_antialias(cairo.ANTIALIAS_GRAY)

        def sq(x,y):
            c.rectangle(x,y,mm(10),mm(10))
            c.fill()
        
        w=100
        h=100
        for xm in range(0,w,20):
            for ym in range(0,h,20):
                sq(mm(xm),mm(ym))
        for xm in range(10,w,20):
            for ym in range(10,h,20):
                sq(mm(xm),mm(ym))

        c.set_line_width(1)
        c.move_to(mm(100),0)
        c.rel_line_to(0,mm(100))
        c.rel_line_to(mm(-100),0)
        c.stroke()

        c.set_line_width(3)
        v = 0.5
        c.set_source_rgb(v,v,v)
        c.move_to(mm(50),0)
        c.rel_line_to(0,mm(100))
        c.move_to(0,mm(50))
        c.rel_line_to(mm(100),0)
        c.stroke()
