import gtk
import sugar
import util
from sugar.activity import activity
from gettext import gettext as _

class Activity(activity.Activity):

    def __init__(self, handle, browser=None):
        activity.Activity.__init__(self, handle)

        toolbox = activity.ActivityToolbox(self)
        toolbox.show()
        self.set_toolbox(toolbox)

        tab_text = _(sugar.activity.activity.get_bundle_name())
        self.toolbar = gtk.Toolbar()
        self.toolbar.show()
        toolbox.add_toolbar(tab_text,self.toolbar)

        self._page_box = gtk.VBox()
        self._page_box.show()
        self.set_canvas(self._page_box)
        self.page = None

        self._init_api = SubActivityInitApi(self)
        self.configure_subactivities()


    def set_page(self,widget):

        for w in self._page_box.get_children():
            self._page_box.remove(w)

        self._page_box.pack_start(widget, True,True)
        widget.show()
        
        self.page = widget


    def add_subactivity(self,module_name):

        d = {'api': self._init_api}
        code = ("import "+module_name+"\n"+
                ""+module_name+".subactivity_init(api)\n")
        exec code in d


class SubActivityInitApi:

    def __init__(self,activity):
        self.activity = activity

    def declare_subactivity(self,icon,page,toolbar=None):

        button = sugar.graphics.toolbutton.ToolButton(icon)
        button.connect('clicked',self._cb_set_page,page)
        button.show()
        
        self.activity.toolbar.insert(button,-1)

        if not self.activity.page:
            self.activity.set_page(page)

    def _cb_set_page(self,button,page):
        self.activity.set_page(page)
        self.activity.queue_draw()
